Index: sandbox/workflow/trunk/redirect.php
===================================================================
--- sandbox/workflow/trunk/redirect.php	(revision 1468)
+++ sandbox/workflow/trunk/redirect.php	(revision 2372)
@@ -12,4 +12,4 @@
 if (empty($_SESSION))
 	exit(0);
-$GLOBALS['workflow']['factory']->getInstance('ResourcesRedirector')->redirect();
+Factory::getInstance('ResourcesRedirector')->redirect();
 ?>
Index: sandbox/workflow/trunk/controller.php
===================================================================
--- sandbox/workflow/trunk/controller.php	(revision 1484)
+++ sandbox/workflow/trunk/controller.php	(revision 2372)
@@ -16,5 +16,5 @@
 	{
 		require_once dirname(__FILE__) . '/inc/common.inc.php';
-		$GLOBALS['workflow']['factory']->getInstance('WorkflowMacro')->prepareEnvironment();
+		Factory::getInstance('WorkflowMacro')->prepareEnvironment();
 	}
 
Index: sandbox/workflow/trunk/inc/class.workflow_processmonitor.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.workflow_processmonitor.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.workflow_processmonitor.inc.php	(revision 2372)
@@ -17,5 +17,5 @@
 		function workflow_processmonitor()
 		{
-			parent::ProcessMonitor($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::ProcessMonitor(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 	}
Index: sandbox/workflow/trunk/inc/class.bo_utils.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.bo_utils.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.bo_utils.inc.php	(revision 2372)
@@ -11,6 +11,4 @@
 
 require_once 'class.bo_ajaxinterface.inc.php';
-require_once GALAXIA_LIBRARY . SEP . 'src' . SEP . 'GUI' . SEP . 'GUI.php';
-require_once GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ActivityManager.php';
 
 /**
@@ -34,5 +32,5 @@
 	{
 		parent::bo_ajaxinterface();
-		$this->db = &$GLOBALS['workflow']['workflowObjects']->getDBExpresso();
+		$this->db =& Factory::getInstance('WorkflowObjects')->getDBExpresso();
 	}
 
@@ -88,5 +86,5 @@
 			$ret_name = empty($params['name']) ? 'cn' : $params['name'];
 
-			$ajaxConfig = new ajax_config('contactcenter');
+			$ajaxConfig = &Factory::newInstance('ajax_config', 'contactcenter');
 			$config = $ajaxConfig->read_repository();
 
Index: sandbox/workflow/trunk/inc/class.run_activity.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.run_activity.inc.php	(revision 2072)
+++ sandbox/workflow/trunk/inc/class.run_activity.inc.php	(revision 2372)
@@ -10,9 +10,8 @@
 	\**************************************************************************/
 
+	require_once(dirname(__FILE__) . SEP . 'common.inc.php'); 				 /* including common deifinitions */
 	require_once(dirname(__FILE__) . SEP . 'class.WorkflowUtils.inc.php'  ); /* superclass source code       */
 	require_once(dirname(__FILE__) . SEP . 'class.basecontroller.inc.php' ); /* module controller            */
 	require_once(dirname(__FILE__) . SEP . 'class.basemodel.inc.php'      ); /* module logic                 */
-	require_once(dirname(__FILE__) . SEP . 'class.process_factory.inc.php'); /* module process factory class */
-	require_once(dirname(__FILE__) . SEP . 'class.utils.security.php'     ); /* sanitizes input data         */
 
 	/**
@@ -206,12 +205,17 @@
 		{
 			parent::WorkflowUtils();
-			$this->runtime		= CreateObject('workflow.workflow_wfruntime');
+
+			/**
+			 * We should always use newInstance to instantiate
+			 * 'workflow_wfruntime'
+			 */
+			$this->runtime			= &Factory::newInstance('workflow_wfruntime');
 			$this->runtime->setDebug(_DEBUG);
-			//$this->base_activity	= CreateObject('workflow.workflow_baseactivity');
-			//$this->process		= CreateObject('workflow.workflow_process');
-			$this->GUI		= CreateObject('workflow.workflow_gui');
-			$this->categories 	= CreateObject('phpgwapi.categories');
-
-			$this->workflowSmarty = CreateObject('workflow.workflow_smarty', false);
+			//$this->base_activity	= Factory::getInstance('workflow_baseactivity');
+			//$this->process		= Factory::getInstance('workflow_process');
+			$this->GUI				= &Factory::getInstance('workflow_gui');
+			$this->categories 		= &Factory::getInstance('categories');
+
+			$this->workflowSmarty 	= &Factory::getInstance('workflow_smarty', false);
 			// TODO: open a new connection to the database under a different username to allow privilege handling on tables
 			/* CELEPAR */
@@ -301,5 +305,5 @@
 			$this->process_version	= $this->process->getVersion();
 			$this->activity_name	= $activity->getName();
-			$this->user_name	= $GLOBALS['phpgw']->accounts->id2name($GLOBALS['user']);
+			$this->user_name   		= $GLOBALS['phpgw']->accounts->id2name($GLOBALS['user']);
 			$this->view_activity	= $this->GUI->gui_get_process_view_activity($this->process_id);
 
@@ -318,8 +322,8 @@
 			$GLOBALS['workflow']['wf_workflow_path']			= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'workflow';
 			$GLOBALS['workflow']['wf_resources_path']			= $GLOBALS['phpgw_info']['server']['webserver_url'] . SEP . 'workflow/redirect.php?pid=' . $this->process_id . '&file=';
-			$GLOBALS['workflow']['wf_default_resources_path']	= $GLOBALS['workflow']['factory']->getInstance('TemplateServer')->generateLink('processes');
-			$GLOBALS['workflow']['wf_workflow_resources_path']	= $GLOBALS['workflow']['factory']->getInstance('TemplateServer')->generateLink('');
+			$GLOBALS['workflow']['wf_default_resources_path']	= Factory::getInstance('TemplateServer')->generateLink('processes');
+			$GLOBALS['workflow']['wf_workflow_resources_path']	= Factory::getInstance('TemplateServer')->generateLink('');
 			$GLOBALS['workflow']['wf_activity_url']				= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'index.php?menuaction=workflow.'.get_class($this).'.go&activity_id='.$activity_id;
-			$GLOBALS['workflow']['wf_user_cnname']				= $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($GLOBALS['user']);
+			$GLOBALS['workflow']['wf_user_cnname']				= Factory::getInstance('WorkflowLDAP')->getName($GLOBALS['user']);
 			$GLOBALS['workflow']['wf_back_link']				= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'workflow'.SEP.'index.php?start_tab=1';
 			$GLOBALS['workflow']['wf_js_path']					= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'workflow'.SEP.'js'.SEP.'jscode';
@@ -376,5 +380,5 @@
 
 				/* check some permissions */
-				if (($newUser == '*') || (!$this->runtime->checkUserRun($newUser)) || ($GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($newUser) === false))
+				if (($newUser == '*') || (!$this->runtime->checkUserRun($newUser)) || (Factory::getInstance('WorkflowLDAP')->getName($newUser) === false))
 				{
 					$_SESSION['phpgw_info']['workflow']['user_groups'] = $actualUserGroups;
@@ -386,5 +390,5 @@
 					return false;
 				}
-				$smarty = CreateObject('workflow.process_smarty');
+				$smarty = Factory::getInstance('process_smarty');
 			}
 
@@ -399,5 +403,5 @@
 				/* #celepar# smarty code*/
 
-				$smarty = CreateObject('workflow.process_smarty');
+				$smarty = Factory::getInstance('process_smarty');
 
 				$smarty->template_dir  = GALAXIA_PROCESSES.SEP.$this->process->getNormalizedName().SEP.'code'.SEP.'templates';
@@ -438,7 +442,8 @@
 			$env['instance']      =& $instance;                        //process manager instance
 			$env['activity']      =& $activity;                        //activity manager instance
-			$security             =& new SecurityUtils();              //input sanitizer class
+			$security             =& Factory::newInstance('SecurityUtils');              //input sanitizer class
 			$env['request']       =& $security->process($_REQUEST);    //sanitizes input data from client
-			$env['factory']       =& new ProcessFactory();             //instantiation controller class
+			//$env['factory']       =& new ProcessFactory();             //instantiation controller class
+			$env['factory']       =& Factory::getInstance('ProcessWrapperFactory');  //instantiation controller class
 			$env['natural']		  =& wf_create_object('wf_natural');   //data access object instance for mainframe
 			/* END WORKFLOW MVC SETTINGS */
@@ -472,5 +477,15 @@
 
 			/* activate the security policy */
-			$GLOBALS['workflow']['factory']->getInstance('WorkflowSecurity')->enableSecurityPolicy();
+			Factory::getInstance('WorkflowSecurity')->enableSecurityPolicy();
+
+			/**
+			 * XXX
+			 * here we are going to use our new Security static class.
+			 * From now, the factory frontend (static) will forward
+			 * the messages for the process factory instead of Workflow
+			 * factory.
+			 * XXX
+			*/
+			Security::enable();
 
 			/* include the files */
@@ -661,8 +676,8 @@
 			$GLOBALS['workflow']['wf_workflow_path']			= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'workflow';
 			$GLOBALS['workflow']['wf_resources_path']			= $GLOBALS['phpgw_info']['server']['webserver_url'] . SEP . 'workflow/redirect.php?pid=' . $this->process_id . '&file=';
-			$GLOBALS['workflow']['wf_default_resources_path']	= $GLOBALS['workflow']['factory']->getInstance('TemplateServer')->generateLink('processes');
-			$GLOBALS['workflow']['wf_workflow_resources_path']	= $GLOBALS['workflow']['factory']->getInstance('TemplateServer')->generateLink('');
+			$GLOBALS['workflow']['wf_default_resources_path']	= Factory::getInstance('TemplateServer')->generateLink('processes');
+			$GLOBALS['workflow']['wf_workflow_resources_path']	= Factory::getInstance('TemplateServer')->generateLink('');
 			$GLOBALS['workflow']['wf_activity_url']				= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'index.php?menuaction=workflow.'.get_class($this).'.go&activity_id='.$activity_id;
-			$GLOBALS['workflow']['wf_user_cnname']				= $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($GLOBALS['user']);
+			$GLOBALS['workflow']['wf_user_cnname']				= Factory::getInstance('WorkflowLDAP')->getName($GLOBALS['user']);
 			$GLOBALS['workflow']['wf_back_link']				= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'workflow'.SEP.'index.php?start_tab=1';
 			$GLOBALS['workflow']['wf_js_path']					= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'workflow'.SEP.'js'.SEP.'jscode';
@@ -699,7 +714,8 @@
 			$env['instance']      =& $instance;                        //process manager instance
 			$env['activity']      =& $activity;                        //activity manager instance
-			$security             =& new SecurityUtils();              //input sanitizer class
+			$security             =& Factory::newInstance('SecurityUtils'); //input sanitizer class
 			$env['request']       =& $security->process($_REQUEST); //sanitizes input data from client
-			$env['factory']       =& new ProcessFactory();			   //instantiation controller class
+			//$env['factory']       =& new ProcessFactory();			   //instantiation controller class
+			$env['factory']       =& Factory::newInstance('ProcessWrapperFactory');  //instantiation controller class
 			$env['natural']		  =& wf_create_object('wf_natural');   //data access object instance for mainframe
 			/* END WORKFLOW MVC SETTINGS */
@@ -712,8 +728,19 @@
 
 			/* activate the security policy */
-			$GLOBALS['workflow']['factory']->getInstance('WorkflowSecurity')->enableSecurityPolicy();
+			Factory::getInstance('WorkflowSecurity')->enableSecurityPolicy();
+
+			/**
+			 * XXX
+			 * here we are going to use our new Security static class.
+			 * From now, the factory frontend (static) will forward
+			 * the messages for the process factory instead of Workflow
+			 * factory. Note that this is the same comment as the previous
+			 * function... boooring.. =}
+			 * XXX
+			*/
+			Security::enable();
 
 			$GLOBALS['workflow_env'] = &$env;
-			$nc = new NanoController();
+			$nc = &Factory::newInstance('NanoController');
 			$nc->setClassPath(GALAXIA_PROCESSES . SEP . $this->process->getNormalizedName(). SEP . 'code');
 			$nc->iterateOverVirtualRequests();
Index: sandbox/workflow/trunk/inc/class.workflow_baseactivity.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.workflow_baseactivity.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.workflow_baseactivity.inc.php	(revision 2372)
@@ -17,5 +17,5 @@
 		function workflow_baseactivity()
 		{
-			parent::BaseActivity($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::BaseActivity(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 	}
Index: sandbox/workflow/trunk/inc/class.bo_agent_mail_smtp.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.bo_agent_mail_smtp.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.bo_agent_mail_smtp.inc.php	(revision 2372)
@@ -109,6 +109,6 @@
 	{
 		parent::bo_agent();
-		$this->so_agent = CreateObject('workflow.so_agent_mail_smtp');
-		$this->bo_emailadmin = CreateObject('emailadmin.bo');
+		$this->so_agent = Factory::getInstance('so_agent_mail_smtp');
+		$this->bo_emailadmin = Factory::getInstance('bo');
 		//the showProcessConfigurationFields is not done here, quite harder to build
 		$this->ProcessConfigurationFieldsdefault = array(
@@ -312,5 +312,5 @@
 	function init()
 	{
-		$this->mail = CreateObject('phpgwapi.phpmailer');
+		$this->mail = Factory::getInstance('phpmailer');
 		//set the $this->conf
 		$this->getProcessConfigurationFields($this->activity->getProcessId());
@@ -466,5 +466,5 @@
 		}
 
-		$process = CreateObject('workflow.workflow_process');
+		$process = Factory::getInstance('workflow_process');
 		$process->getProcess($this->process_id);
 		$this->process_name = $process->getName();
@@ -637,5 +637,5 @@
 					if ($this->process_name=='')
 					{
-						$process = CreateObject('workflow.workflow_process');
+						$process = Factory::getInstance('workflow_process');
 						$process->getProcess($this->process_id);
 						$this->process_name = $process->getName();
@@ -648,5 +648,5 @@
 					if ($this->process_version=='')
 					{
-						$process = CreateObject('workflow.workflow_process');
+						$process = Factory::getInstance('workflow_process');
 						$process->getProcess($this->process_id);
 						$this->process_name = $process->getName();
@@ -674,5 +674,5 @@
 					if (!is_object($this->account))
 					{
-						$this->account = CreateObject('phpgwapi.accounts');
+						$this->account = Factory::getInstance('accounts');
 					}
 					$ask_user = $this->instance->getOwner();
@@ -683,9 +683,9 @@
 					if (!is_object($this->role_manager))
 					{
-						$this->role_manager = CreateObject('workflow.workflow_rolemanager');
+						$this->role_manager = Factory::getInstance('workflow_rolemanager');
 					}
 					if (!is_object($this->account))
 					{
-						$this->account = CreateObject('phpgwapi.accounts');
+						$this->account = Factory::getInstance('accounts');
 					}
 					$my_subset = array('wf_activity_name' => $this->activity->getName());
@@ -718,5 +718,5 @@
 							if (!is_object($this->account))
 							{
-								$this->account = CreateObject('phpgwapi.accounts');
+								$this->account = Factory::getInstance('accounts');
 							}
 							$ask_user = $this->account->name2id($second_part);
@@ -731,9 +731,9 @@
 							if (!is_object($this->role_manager))
 							{
-								$this->role_manager = CreateObject('workflow.workflow_rolemanager');
+								$this->role_manager = Factory::getInstance('workflow_rolemanager');
 							}
 							if (!is_object($this->account))
 							{
-								$this->account = CreateObject('phpgwapi.accounts');
+								$this->account = Factory::getInstance('accounts');
 							}
 							$my_subset = array('wf_role_name' => $second_part);
Index: sandbox/workflow/trunk/inc/local/classes/class.wf_role.php
===================================================================
--- sandbox/workflow/trunk/inc/local/classes/class.wf_role.php	(revision 1048)
+++ sandbox/workflow/trunk/inc/local/classes/class.wf_role.php	(revision 2372)
@@ -58,6 +58,6 @@
 
 		$this->db = &$GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID;
-		$this->roleManager = CreateObject('workflow.workflow_rolemanager');
-		$this->activityManager = CreateObject('workflow.workflow_activitymanager');
+		$this->roleManager = Factory::getInstance('workflow_rolemanager');
+		$this->activityManager = Factory::getInstance('workflow_activitymanager');
 	}
 
@@ -186,5 +186,5 @@
 			$users = array((int) $users);
 		$roleID = $this->roleManager->get_role_id($this->processID, $roleName);
-		$ldap = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$ldap = Factory::getInstance('WorkflowLDAP');
 		foreach ($users as $user)
 		{
@@ -212,5 +212,5 @@
 		$users = $this->roleManager->list_mapped_users($this->processID, false, array('wf_role_name' => $roleName));
 
-		$ldap = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$ldap = Factory::getInstance('WorkflowLDAP');
 		$output = array();
 		foreach ($users as $id => $login)
@@ -367,5 +367,5 @@
 
 		/* get the roles */
-		$userGroups = $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getUserGroups($userID);
+		$userGroups = Factory::getInstance('WorkflowLDAP')->getUserGroups($userID);
 		$query = 'SELECT DISTINCT role.wf_role_id, role.wf_name, role.wf_description FROM egw_wf_roles role, egw_wf_user_roles user_role WHERE (user_role.wf_role_id = role.wf_role_id) AND (role.wf_p_id = ?) AND (role.wf_role_id = ANY (?))';
 		$query .= ' AND (((user_role.wf_user = ?) AND (user_role.wf_account_type = ?))';
Index: sandbox/workflow/trunk/inc/local/classes/class.wf_instance.php
===================================================================
--- sandbox/workflow/trunk/inc/local/classes/class.wf_instance.php	(revision 1385)
+++ sandbox/workflow/trunk/inc/local/classes/class.wf_instance.php	(revision 2372)
@@ -77,5 +77,5 @@
 	{
 		$instanceID = (int) $instanceID;
-		$instance = CreateObject('workflow.workflow_instance');
+		$instance = Factory::getInstance('workflow_instance');
 		if (!$instance->getInstance($instanceID))
 			return false;
@@ -118,5 +118,5 @@
 		$instance = $this->getInstanceObject($instanceID);
 
-		$runActivity = CreateObject('workflow.run_activity');
+		$runActivity = Factory::getInstance('run_activity');
 
 		ob_start();
@@ -423,6 +423,5 @@
 
 		/* load the required instance (for the required user) */
-		require_once GALAXIA_LIBRARY . SEP . 'src' . SEP . 'GUI' . SEP . 'GUI.php';
-		$GUI = new GUI($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$GUI = &Factory::newInstance('GUI');
 		$userInstance = $GUI->gui_list_user_instances($userID, 0, -1, '', '', "(ga.wf_is_interactive = 'y') AND (gia.wf_activity_id = {$activityID}) AND (gia.wf_instance_id = {$instanceID})", false, $this->processID, true, false, true, false, false, false);
 		$userInstance = $userInstance['data'];
@@ -456,9 +455,6 @@
 		if ($userID !== '*')
 		{
-			require_once dirname(__FILE__) . '/class.wf_role.php';
-			require_once dirname(__FILE__) . '/class.wf_engine.php';
-
-			$wfRole = new wf_role();
-			$engine = new wf_engine();
+			$wfRole = Factory::getInstance('wf_role');
+			$engine = Factory::getInstance('wf_engine');
 			/* get information about the activity */
 			if (($activityInfo = $engine->getActivityInformationByID($activityID)) === false)
@@ -529,6 +525,5 @@
 
 		/* try to get the role id */
-		require_once dirname(__FILE__) . '/class.wf_role.php';
-		$wfRole = new wf_role();
+		$wfRole = Factory::getInstance('wf_role');
 		if (($roleID = $wfRole->getRoleIdByName($roleName)) === false)
 			return false;
Index: sandbox/workflow/trunk/inc/local/classes/class.wf_engine.php
===================================================================
--- sandbox/workflow/trunk/inc/local/classes/class.wf_engine.php	(revision 795)
+++ sandbox/workflow/trunk/inc/local/classes/class.wf_engine.php	(revision 2372)
@@ -68,5 +68,5 @@
 		$flagObject[0] = is_null($this->processManager);
 		if ($flagObject[0])
-			$this->processManager = CreateObject('workflow.workflow_processmanager');
+			$this->processManager = Factory::getInstance('workflow_processmanager');
 
 		$output = array();
@@ -90,6 +90,5 @@
 	function continueInstance($activityID, $instanceID)
 	{
-		require_once 'class.wf_instance.php';
-		$WFInstance = new wf_instance();
+		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->continueInstance($activityID, $instanceID);
 	}
@@ -104,6 +103,5 @@
 	function abortInstance($instanceID)
 	{
-		require_once 'class.wf_instance.php';
-		$WFInstance = new wf_instance();
+		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->abort($instanceID);
 	}
@@ -119,6 +117,5 @@
 	function setInstanceName($instanceID, $name)
 	{
-		require_once 'class.wf_instance.php';
-		$WFInstance = new wf_instance();
+		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->setName($instanceID, $name);
 	}
@@ -134,6 +131,5 @@
 	function setInstancePriority($instanceID, $priority)
 	{
-		require_once 'class.wf_instance.php';
-		$WFInstance = new wf_instance();
+		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->setPriority($instanceID, $priority);
 	}
@@ -149,6 +145,5 @@
 	function getIdleInstances($numberOfDays, $activities = null)
 	{
-		require_once 'class.wf_instance.php';
-		$WFInstance = new wf_instance();
+		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->getIdle($numberOfDays, $activities);
 	}
@@ -175,6 +170,5 @@
 	function getInstancesByName($name)
 	{
-		require_once 'class.wf_instance.php';
-		$WFInstance = new wf_instance();
+		$WFInstance = &Factory::getInstance('wf_instance');
 		$preOutput = $WFInstance->getByName($name);
 		$output = array();
@@ -197,6 +191,5 @@
 	function getChildInstances($instanceID = null, $activityID = null)
 	{
-		require_once 'class.wf_instance.php';
-		$WFInstance = new wf_instance();
+		$WFInstance = &Factory::getInstance('wf_instance');
 		$preOutput = $WFInstance->getChildren($instanceID, $activityID);
 		$output = array();
@@ -217,6 +210,5 @@
 	function getInstanceProperties($instanceID)
 	{
-		require_once 'class.wf_instance.php';
-		$WFInstance = new wf_instance();
+		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->getProperties($instanceID);
 	}
@@ -231,6 +223,5 @@
 	function getChildInstanceProperties($instanceID)
 	{
-		require_once 'class.wf_instance.php';
-		$WFInstance = new wf_instance();
+		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->getProperties($instanceID);
 	}
@@ -247,5 +238,5 @@
 		$flagObject[0] = is_null($this->acl);
 		if ($flagObject[0])
-			$this->acl = CreateObject('workflow.workflow_acl');
+			$this->acl = Factory::getInstance('workflow_acl');
 
 		$output = $this->acl->getUserPermissions($type, $uid);
@@ -268,5 +259,5 @@
 		$flagObject[0] = is_null($this->acl);
 		if ($flagObject[0])
-			$this->acl = CreateObject('workflow.workflow_acl');
+			$this->acl = Factory::getInstance('workflow_acl');
 
 		$output = $this->acl->getUserGroupPermissions($type, $uid);
@@ -346,6 +337,5 @@
 	function getUserInstances($users, $activities = null, $status = null)
 	{
-		require_once 'class.wf_instance.php';
-		$WFInstance = new wf_instance();
+		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->getByUser($users, $activities, $status);
 	}
@@ -360,6 +350,5 @@
 	function setInstanceProperty($instanceID, $nameProperty, $value)
 	{
-		require_once 'class.wf_instance.php';
-		$WFInstance = new wf_instance();
+		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->setProperty($instanceID, $nameProperty, $value);
 	}
@@ -377,6 +366,5 @@
 	function checkUserAccessToInstance($userID, $instanceID, $activityID, $writeAccess = true)
 	{
-		require_once 'class.wf_instance.php';
-		$WFInstance = new wf_instance();
+		$WFInstance = &Factory::getInstance('wf_instance');
 		return $WFInstance->checkUserAccess($userID, $instanceID, $activityID, $writeAccess);
 	}
Index: sandbox/workflow/trunk/inc/local/classes/class.JobBase.php
===================================================================
--- sandbox/workflow/trunk/inc/local/classes/class.JobBase.php	(revision 1437)
+++ sandbox/workflow/trunk/inc/local/classes/class.JobBase.php	(revision 2372)
@@ -89,9 +89,9 @@
 	{
 		require_once 'common.inc.php';
-		$GLOBALS['workflow']['factory']->getInstance('WorkflowMacro')->prepareEnvironment();
+		Factory::getInstance('WorkflowMacro')->prepareEnvironment();
 		$this->jobID = $jobID;
 		$this->processID = $processID;
 		$this->currentDate = $currentDate;
-		$this->jobManager = &$GLOBALS['workflow']['factory']->getInstance('WorkflowJobManager');
+		$this->jobManager = Factory::getInstance('WorkflowJobManager');
 		$this->testMode = $testMode;
 		$this->maximumExecutionTime = $maximumExecutionTime;
@@ -148,10 +148,8 @@
 	final private function prepareEnvironment()
 	{
-		$GLOBALS['workflow']['factory']->getInstance('WorkflowMacro')->prepareProcessEnvironment($this->processID);
-
-		require_once PHPGW_SERVER_ROOT . '/workflow/inc/class.process_factory.inc.php';
+		Factory::getInstance('WorkflowMacro')->prepareProcessEnvironment($this->processID);
 
 		$this->environment = array();
-		$this->environment['factory']  = &new ProcessFactory();
+		$this->environment['factory']  = &Factory::newInstance('ProcessWrapperFactory');
 	}
 
@@ -202,5 +200,5 @@
 	final public function createNewInstance($startActivityId, $instanceName=false, $properties=false, $user=false)
 	{
-		$activityManager = CreateObject('workflow.workflow_activitymanager');
+		$activityManager = Factory::getInstance('workflow_activitymanager');
 		$activity = $activityManager->get_activity($startActivityId);
 
Index: sandbox/workflow/trunk/inc/local/classes/class.wf_ldap.php
===================================================================
--- sandbox/workflow/trunk/inc/local/classes/class.wf_ldap.php	(revision 1067)
+++ sandbox/workflow/trunk/inc/local/classes/class.wf_ldap.php	(revision 2372)
@@ -1,4 +1,3 @@
 <?php
-require_once PHPGW_SERVER_ROOT . SEP . 'workflow' . SEP . 'inc' . SEP . 'local' . SEP . 'classes' . SEP . 'class.wf_cached_ldap.php';
 
 /**
@@ -41,5 +40,5 @@
 	function wf_ldap()
 	{
-		$tmpLDAP = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$tmpLDAP = Factory::getInstance('WorkflowLDAP');
 		$this->user_context  = $tmpLDAP->getUserContext();
 		$this->group_context = $tmpLDAP->getGroupContext();
@@ -47,5 +46,5 @@
 		$this->ds = &$GLOBALS['workflow']['workflowObjects']->getLDAP();
 
-		$this->cachedLDAP = new wf_cached_ldap();
+		$this->cachedLDAP = &Factory::getInstance('wf_cached_ldap');
 		$this->cachedLDAP->setOperationMode($this->cachedLDAP->OPERATION_MODE_LDAP);
 	}
Index: sandbox/workflow/trunk/inc/local/classes/class.wf_mail.php
===================================================================
--- sandbox/workflow/trunk/inc/local/classes/class.wf_mail.php	(revision 795)
+++ sandbox/workflow/trunk/inc/local/classes/class.wf_mail.php	(revision 2372)
@@ -39,5 +39,5 @@
 		$requiredConfiguration = array('mail_smtp_profile' => false);
 		$configuration = $GLOBALS['workflow']['wf_runtime']->process->getConfigValues($requiredConfiguration);
-		$bo_emailadmin = CreateObject('emailadmin.bo');
+		$bo_emailadmin = Factory::getInstance('bo');
 		$profileData = $bo_emailadmin->getProfile($configuration['mail_smtp_profile']);
 
Index: sandbox/workflow/trunk/inc/class.workflow_acl.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.workflow_acl.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.workflow_acl.inc.php	(revision 2372)
@@ -30,5 +30,5 @@
 	function workflow_acl()
 	{
-		parent::so_adminaccess($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		parent::so_adminaccess(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 	}
 
Index: sandbox/workflow/trunk/inc/class.bo_adminaccess.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.bo_adminaccess.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.bo_adminaccess.inc.php	(revision 2372)
@@ -11,8 +11,5 @@
 
 require_once('class.bo_ajaxinterface.inc.php');
-require_once('class.so_adminaccess.inc.php');
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ProcessManager.php');
 require_once(PHPGW_API_INC . SEP . 'common_functions.inc.php');
-require_once(PHPGW_API_INC . SEP . 'class.acl.inc.php');
 
 /**
@@ -43,8 +40,8 @@
 		parent::bo_ajaxinterface();
 
-		if (!$GLOBALS['workflow']['factory']->getInstance('workflow_acl')->checkWorkflowAdmin($_SESSION['phpgw_info']['workflow']['account_id']))
+		if (!Factory::getInstance('workflow_acl')->checkWorkflowAdmin($_SESSION['phpgw_info']['workflow']['account_id']))
 			exit(serialize(array('error' => 'Você não tem permissão para executar esta operação.')));
 
-		$this->so = new so_adminaccess($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$this->so = &Factory::getInstance('so_adminaccess', Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 	}
 
@@ -57,5 +54,5 @@
 	function get_all_processes()
 	{
-		$proc_mng = new ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$proc_mng = &Factory::newInstance('ProcessManager');
 		$proc_list = $proc_mng->list_processes(0,-1,'wf_name__ASC');
 
@@ -315,5 +312,5 @@
 	{
 		$GLOBALS['phpgw']->db = $GLOBALS['ajax']->db;
-		$acl = new ACL();
+		$acl = &Factory::getInstance('acl');
 		$output = $this->so->getUserNames($acl->get_ids_for_location('admin_workflow', 1, 'workflow'));
 		unset($GLOBALS['phpgw']->db);
@@ -332,5 +329,5 @@
 		$ids = explode('.', str_replace('g', '', str_replace('u', '', $params['user_ids'])));
 		$GLOBALS['phpgw']->db = $GLOBALS['ajax']->db;
-		$acl = new ACL();
+		$acl = &Factory::getInstance('acl');
 		foreach ($ids as $id)
 			$acl->add_repository('workflow', 'admin_workflow', $id, 1);
@@ -350,5 +347,5 @@
 	{
 		$GLOBALS['phpgw']->db = $GLOBALS['ajax']->db;
-		$acl = new ACL();
+		$acl = &Factory::getInstance('acl');
 		$acl->delete_repository('workflow', 'admin_workflow', (int) $params['admin_id']);
 		unset($GLOBALS['phpgw']->db);
Index: sandbox/workflow/trunk/inc/class.powergraphic.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.powergraphic.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.powergraphic.inc.php	(revision 2372)
@@ -139,7 +139,7 @@
 
 
-
-
-$PowerGraphic = new powergraphic;
+require_once 'common.inc.php';
+
+$PowerGraphic = &Factory::newInstance('powergraphic');
 
 $PowerGraphic->start();
